/* $Id: graphic.h,v 1.4 1998/10/25 02:03:55 marcus Exp $
******************************************************************************

   KGIcon - graphic device definitions

   Copyright (C) 1996	Steffen Seeger	[seeger@ggi-project.org]

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************
*/

#ifndef	_KGI_GRAPHIC_H
#define	_KGI_GRAPHIC_H

#define	MAX_NR_MMIO_REGIONS	16	/* max. mmio regions per card	*/
#define	MAX_NR_ACCEL_REGIONS	8	/* max. accelerators per card	*/

#include <kgi/kgi.h>

struct kgi_graphic {

	struct kgi_device	dev;	/* normal device state	*/

	kgi_uint	io_cnt;
	void		*io_buf;
	void		*io_res;
	kgi_uint	io_lock;

	kgi_uint	can_set_mode;

	struct kgi_mmio_mapping *mmio_map[MAX_NR_MMIO_REGIONS];
	struct kgi_mmio_region	*mmio[MAX_NR_MMIO_REGIONS];

	struct kgi_accel_mapping *accel_map[MAX_NR_ACCEL_REGIONS];
	struct kgi_accel	*accel[MAX_NR_ACCEL_REGIONS];

	kgi_gc		*gc;		/* gc as mapped into kernelspace */

	/* !!! add other state not already in dev!	*/
};

#endif	/* _KGI_GRAPHIC_H */
